/*

 todo: set quantities
 todo: tie widget quntities to game variables
 todo: set up timeline
 todo: set up dynamics
 todo: set up dialogs
 todo: release resources?
 todo: allow events to, like, end the game, or whatever
 todo: playsample doesn't seem to work:/
 todo: when pop bars move left, blood spatter
 todo: as population decreases, blot out parts of the city
 todo: as population increases, add new bits in(i guess)

 todo: ALLOW INGAME RESTART
 */
#include <allegro.h>
#include <iostream>
#include <vector>
#include <time.h>
#include <algorithm>
#include <sstream>
#include "boost/foreach.hpp"
//#include <ApplicationServices/ApplicationServices.h>

using namespace std;

const int tilesize=10;

#define foreach BOOST_FOREACH

typedef float num;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"

BITMAP* buffer;
const int BMPCOUNT=13;

BITMAP* bitmap[BMPCOUNT];

const char* bitmapnames[BMPCOUNT]={
"bmp/instructions.bmp",
"bmp/intro.bmp",
"bmp/level1a.bmp",
"bmp/level1b.bmp",
"bmp/level1bg.bmp",
"bmp/level2b.bmp",
"bmp/level3a.bmp",
"bmp/level3b.bmp",
"bmp/level3bg.bmp",
"bmp/overlay.bmp",
"bmp/pointer.bmp",
"bmp/portraits.bmp",
"bmp/title.bmp"};


int showruntimer;
#include "printwrap.h"

int level;

struct FallingData {
	int x;
	int y;
	int tx;
	int ty;
	int life;
};


vector<FallingData> falling;

const int FADEMAX=180;
bool fade;
int fadecounter;
bool overatfade;
float stopwatch;

bool sceneend;
const int ts=13;
char *statustext="";
bool warover=false;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;
int runframe;
string scorestring;

bool prevpressedz=1;
bool showdialogue;
bool showmenu;


char *nulltext="";

int curscore;

void setscore()
{
	stringstream ss;
	ss<<curscore;
	scorestring=ss.str();
}

void enable_buttons();

unsigned int curdialoguepos;

bool talkmode;
bool thinkmode;
bool spacepressed;
string curstring;


int consequences=0;

struct CLine
{
	int speaker;
	string dialogue;
};

vector<CLine> dialogues[6];

class IntroLoop
{
public:
	static void initialize()
	{
		speed_count=0;
		titletimer=0;
		finishedtitle=false;
	}

	static bool quitcondition()
	{
		return quit||warover||finishedtitle;
	}

	static void logic()
	{
		titletimer++;

		if (titletimer>60|| (titletimer>22&&(key[KEY_SPACE]||key[KEY_A])))
		{
			finishedtitle=true;
		}
	}

	static void draw()
	{
		blit(bitmap[1], buffer, 0, 0, 0, 0, 160, 120);
	}
};

class TitleLoop
{
private:
	static bool begin;
	static int selected;
	static bool upheld;
	static bool downheld;
	static bool spaceheld;
public:
	static bool infopage;

	static void initialize()
	{
		begin=false;
		selected=0;
		upheld=true;
		downheld=true;
		spaceheld=true;
		infopage=false;
	}

	static void logic()
	{
		if (key[KEY_UP])
		{
			if (!infopage&&!upheld)
			{
				selected=(selected+2)%3;
				upheld=true;
				playsound(2);
			}
		}
		else
			upheld=false;

		if (key[KEY_DOWN])
		{
			if (!infopage&&!downheld)
			{
				selected=(selected+1)%3;
				downheld=true;
				playsound(2);
			}
		}
		else
			downheld=false;

		if (key[KEY_SPACE]||key[KEY_A])
		{

			if (!spaceheld)
			{
				if (!infopage)
				{
					switch (selected)
					{
						case 0:
							begin=true;
							playsound(4);
							break;
						case 1:
							infopage=true;
							spaceheld=true;
							playsound(2);
							break;
						case 2:
							quit=true;
							playsound(2);
							break;
					}
				}
				else
				{
					infopage=false;
					spaceheld=true;
					playsound(2);

				}
			}

		}
		else
			spaceheld=false;

	}

	static bool quitcondition()
	{
		return quit||begin;
	}

	static void draw()
	{
		if (!infopage)
		{
			blit(bitmap[12], buffer, 0, 0, 0, 0, 160, 120);
			masked_blit(bitmap[10],buffer,0,0,101,39+9*selected,7,5);
		}
		else
		{
			blit(bitmap[0],buffer,0,0,0,0,160,120);
		}
	}

};

bool TitleLoop::begin=false;
int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;
bool TitleLoop::infopage=false;

int xmargin=44;
int ymargin=0;



template<class T>
void loop();


float pos;
float vel;
float accel;
int lastposint;
bool runanim;

enum GameState {gs_intro,gs_game,gs_outro};
GameState gamestate;
int cutscenetimer;
struct PosFrame
{
	int pos;
	int frame;
};

PosFrame mpawn;
PosFrame dpawn;
PosFrame doctpawn;

int forwardmover=0;

int cx;
int cy;
bool cd;

const int MW=4;
const int MH=9;

int play[MW*MH];
bool removed[MW*MH];

const bool matters[MW*MH]=
{
0,1,1,0,
0,1,1,0,
1,1,1,1,
1,1,1,1,
1,1,1,1,
1,1,1,1,
0,1,1,0,
0,1,1,0,
1,1,1,1
};

const int  ordercount[3]=
{6,6,4};

const int orders[3][MW*MH]=
{
{
0,1,1,0,
0,0,0,0,
0,5,5,0,
0,5,5,0,
0,4,4,0,
0,6,6,0,
0,0,0,0,
0,0,0,0,
2,2,3,3
},
{
0,0,0,0,
0,0,0,0,
0,5,5,0,
1,5,5,2,
1,5,5,2,
1,6,6,2,
0,0,0,0,
0,4,3,0,
4,4,3,3
},
{
0,0,0,0,
0,0,0,0,
2,2,2,2,
2,2,2,2,
0,2,2,0,
0,1,1,0,
0,1,1,0,
0,1,1,0,
3,3,4,4
}
};

int target;

//-1 fail, 0 nothing, 1 success
int checkorders()
{
	if (target<=ordercount[level])
	{

		bool goodmatchfound=false;
		bool badmatchfound=false;

		for (int i=1;i<=ordercount[level];i++)
		{
			bool counterfound=false;
			for (int j=0;j<MW*MH;j++)
			{
				if (orders[level][j]==i)
				{
					if (play[j]!=j)
					{
						counterfound=true;
						break;
					}
				}
			}

			if (!counterfound)
			{
				if (i==target)
					goodmatchfound=true;
				else if (i>target)
					badmatchfound=true;

			}
		}

		if (target<=ordercount[level])
		{
			bool counterfound=false;
			for (int j=0;j<MW*MH;j++)
			{
				if (matters[j]&&(play[j]!=j))
				{
					counterfound=true;
					break;
				}
			}
			if (!counterfound)
				badmatchfound=true;
		}

		if (badmatchfound)
			return -1;
		else if (goodmatchfound)
			return 1;
		else
			return 0;

	}
	else
	{
		bool counterfound=false;
		for (int j=0;j<MW*MH;j++)
		{
			if (matters[j]&&(play[j]!=j))
			{
				counterfound=true;
				break;
			}
		}
		if (counterfound)
			return 0;
		else
			return 1;
	}

	//shouldn't get here
	return 0;
}

void shuffle()
{
	for (int i=0;i<MW*MH;i++)
	{
		play[i]=i;
		if (level<2)
			removed[i]=false;
		else
			removed[i]=true;
	}

	for (int i=(MW*MH-1);i>1;i--)
	{
		int r=rand()%(i-1);

		std::cout<<"r"<<r;
		swap(play[i],play[r]);
	}

	for (int i=0;i<(MW*MH);i++)
	{
		//check that nothing is in the place where it should be
		//(easy way to avoid matches at the start of the game)
		if (play[i]==i)
		{
			int r = rand()%(MW*MH-1);
			if (r>=i)
				r++;

			swap(play[i],play[r]);
		}

	}
}

bool pressed[7];

int swaptimer=0;
int sx;
int sy;
int sd;

int orderticker=0;

int endwait;
int starttimer;

bool offScreen(FallingData& fd)
{
	return (fd.y>120);
}

void startlevel()
{
	starttimer=30;
	stopmusic();
	orderticker=0;
	cx=0;
	cy=0;
	cd=0;
	shuffle();
	for (int i=0;i<7;i++)
		pressed[i]=true;

	target=1;

	curdialoguepos=0;
	gamestate=gs_intro;
	swaptimer=0;
	falling.erase( falling.begin(),  falling.end());
}


void endlevel()
{
	if (level<2)
		playmusic(1);
	else
		stopmusic();
	endwait=60;
	gamestate=gs_outro;
	curdialoguepos=0;
}

class GameLoop
{
public:
	static void initialize()
	{
		cx=0;
		cy=0;
		cd=0;

        forwardmover=0;
		pos=0;
		vel=0;
		accel=0;
		spacepressed=true;
		runanim=false;
		runframe=0;
		showruntimer=0;
		stopwatch=0;
		cutscenetimer=0;
		mpawn.pos=-100;
		mpawn.frame=0;
		dpawn.pos=-100;
		dpawn.frame=0;
		doctpawn.pos=-100;
		doctpawn.frame=0;
		leave=false;
		warover=false;
		level=0;

		curdialoguepos=0;

		shuffle();
		curscore=0;
		setscore();

		startlevel();
	}

	static bool quitcondition()
	{
		return quit||leave||warover;
	}

	static void logic()
	{

		if (starttimer>0)
		{
			starttimer--;

			if (starttimer==0)
			{
				if (gamestate==gs_intro)
				{
					if (level<2)
						playmusic(0);
					else
						stopmusic();
				}
				else
				{//must be in game
					switch (level)
					{
						case 0:
							playmusic(2);
							break;
						case 1:
							playmusic(3);
							break;
						case 2:
							playmusic(4);
							break;

					}
				}
			}

			return;
		}


		switch (gamestate)
		{


			case gs_intro:
			{
				if (key[KEY_SPACE])
				{
					if (!pressed[6])
					{
						curdialoguepos++;
						if (curdialoguepos==dialogues[level*2].size())
						{
							gamestate=gs_game;
							starttimer=30;
							stopmusic();
						}
					}
					pressed[6]=true;
				}
				else
					pressed[6]=false;
			}
				break;
			case gs_game:
			{

				orderticker=(orderticker+1) % 32;

				bool moved=false;
				if (key[KEY_UP])
				{
					if (!pressed[0])
					{
						if (cy>0)
							cy--;
						moved=true;
					}

					pressed[0]=true;
				}
				else
				{
					pressed[0]=false;
				}


				if (key[KEY_DOWN])
				{
					if (!pressed[1] && !moved)
					{
						if (cy<(7+cd))
							cy++;
						moved=true;
					}
					pressed[1]=true;
				}
				else
				{
					pressed[1]=false;
				}

				if (key[KEY_LEFT])
				{
					if (!pressed[2]&&!moved)
					{
						if (cx>0)
							cx--;
						moved=true;
					}
					pressed[2]=true;
				}
				else
				{
					pressed[2]=false;
				}

				if (key[KEY_RIGHT])
				{
					if (!pressed[3]&&!moved)
					{
						if (cx<(3-cd))
							cx++;
						moved=true;
					}
					pressed[3]=true;
				}
				else
				{
					pressed[3]=false;
				}

				if (key[KEY_D])
				{
					if (!pressed[4])
					{

						cd=!cd;
						if (cd)
						{//if horizontal
							if (cx==3)
								cx=2;
						}
						else
						{
							if (cy==8)
								cy=7;
						}
						moved=true;

					}
					pressed[4]=true;
				}
				else
				{
					pressed[4]=false;
				}

				if (key[KEY_S])
				{
					if (!pressed[5]&&swaptimer==0)
					{
						swaptimer=9;
						sx=cx;
						sy=cy;
						sd=cd;
						moved=true;
					}
					pressed[5]=true;
				}
				else
				{
					pressed[5]=false;
				}

				if (moved)
					playsound(3);

				if (swaptimer>0)
				{
					swaptimer--;
					if (swaptimer==0)
					{
						if (sd)
							swap(play[sx+MW*sy],play[sx+1+MW*sy]);
						else
							swap(play[sx+MW*(sy)],play[sx+MW*(sy+1)]);

						switch (checkorders())
						{
							case -1:
								playsound(1);
								swaptimer=9;
								curscore-=50;
								setscore();
								break;
							case 0:
								break;
							case 1:
								//DOFF!
								curscore+=100;
								setscore();
								for (int i=0;i<MW*MH;i++)
								{
									if (orders[level][i]==target)
									{
										if (level<2)
										{
											removed[i]=true;
											falling.push_back((FallingData){(i%MW)*9,9+(i/MW)*9,9*(play[i]%MW),9*(play[i]/MW)});
										}
										else
											removed[i]=false;
									}
								}
								if (target>ordercount[level])
								{
									endlevel();
								}
								else
								{
									target++;
									playsound(4);
								}
								break;

						}

					}
				}

				foreach(FallingData& f, falling)
				{
					f.y++;
				}

				falling.erase( remove_if(falling.begin(), falling.end(),offScreen),
						falling.end());


			}
				break;
			case gs_outro:
			{
				if (endwait>0)
				{
					endwait--;
					if (endwait==0)
					{
						orderticker=16;
						if (level<2)
							playmusic(0);
					}
				}
				else
				{

					if (key[KEY_SPACE])
					{
						if (!pressed[6])
						{
							curdialoguepos++;
							if (curdialoguepos>=dialogues[level*2+1].size())
							{

								if (level<2)
								{
									level++;
									startlevel();
									return;
								}
								else
								{
									quit=true;
								}
							}
						}
						pressed[6]=true;
					}
					else
						pressed[6]=false;

				}
			}
				break;
		}

	}

	static void draw()
	{
		if (starttimer>0&&gamestate==gs_intro)
		{
			clear_to_color(buffer, makecol(0,0,0));
			return;
		}

		switch (gamestate)
		{

			case gs_intro:
			{
				if (level<2)
					blit(bitmap[4],buffer,0,0,0,0,160,120);
				else
					blit(bitmap[8],buffer,0,0,0,0,160,120);

					rectfill(buffer, 6, 34, 152	, 110, makecol(0,0,0));
					rect(buffer, 6, 34, 152, 110, makecol(255,255,255));
					blit(bitmap[11],buffer,17*dialogues[level*2][curdialoguepos].speaker,0,15,46,17,18);
					wrapprint(dialogues[level*2][curdialoguepos].dialogue, 35, 40,13);

			}
				break;
			case gs_game:
			{



				//clear_to_color(buffer, makecol(255,255,255));
				if (level<2)
					blit(bitmap[4],buffer,0,0,0,0,160,120);
				else
					blit(bitmap[8],buffer,0,0,0,0,160,120);

				masked_blit(bitmap[9], buffer, 0, 0, 0, 0, 160, 120);

				BITMAP* fg=NULL;
				BITMAP* bg=NULL;
				switch (level)
				{
					case 0:
						bg=bitmap[2];
						fg=bitmap[3];
						break;
					case 1:
						bg=bitmap[2];
						fg=bitmap[5];
						break;
					case 2:
						bg=bitmap[6];
						fg=bitmap[7];
						break;
				}


				//draw figure to right

				masked_blit(bg,buffer,0,0,90,9,36,81);



				//draw tiles
				for (int i=0;i<MW*MH;i++)
				{

					int srcx = play[i]%MW;
					int srcy = play[i]/MW;

					int x = i%MW;
					int y = i/MW;

					masked_blit(bg,buffer,9*srcx,9*srcy,36+9*x,9+9*y,9,9);

					if (!removed[play[i]])
					{
						masked_blit(fg,buffer,9*srcx,9*srcy,36+9*x,9+9*y,9,9);
						masked_blit(fg,buffer,9*srcx,9*srcy,90+9*srcx,9+9*srcy,9,9);

					}

					if (orders[level][play[i]]==target||(target>ordercount[level]&&matters[play[i]]&&(play[i]!=i)))
					{

						if (orderticker/16!=0)
						{
							rect(buffer,90+9*srcx,9+9*srcy,90+9*srcx+8,9+8+9*srcy,makecol(255,255,0));
						}
					}
				}

				switch (level)
				{
					case 0:

						textout_ex(buffer, font, "LEVEL 1", 93, 100, makecol(255,255,255),  makecol(0,0,0));
						break;
					case 1:
						textout_ex(buffer, font, "LEVEL 2", 93, 100, makecol(255,255,255),  makecol(0,0,0));
						break;
					case 2:
						textout_ex(buffer, font, "LEVEL 3", 93, 100, makecol(255,255,255),  makecol(0,0,0));
						break;
				}

				textout_right_ex(buffer, font, scorestring.c_str(), 62, 100, makecol(255,255,255),makecol(0,0,0));

				if (starttimer>0)
					break;

				if (swaptimer>0)
				{
					if (sd)
					{//horizontal
						int src1=sx+MW*sy;
						int src1x=play[sx+MW*sy]%MW;
						int src1y=play[sx+MW*sy]/MW;
						int src2=sx+1+MW*sy;
						int src2x=play[sx+1+MW*sy]%MW;
						int src2y=play[sx+1+MW*sy]/MW;
						rectfill(buffer, 36+9*sx, 9+9*sy, 36+9+8+9*sx, 9+8+9*sy, makecol(0,0,0));

						//horizontal swap
						// x1->x1+t
						// x2->x2-t

						masked_blit(bg,buffer,9*src1x,9*src1y,36+9*sx+9-swaptimer,9+9*sy,9,9);
						if (!removed[play[src1]])
						{
							masked_blit(fg,buffer,9*src1x,9*src1y,36+9*sx+9-swaptimer,9+9*sy,9,9);
						}

						masked_blit(bg,buffer,9*src2x,9*src2y,36+9*(sx+1)-9+swaptimer,9+9*sy,9,9);
						if (!removed[play[src2]])
						{
							masked_blit(fg,buffer,9*src2x,9*src2y,36+9*(sx+1)-9+swaptimer,9+9*sy,9,9);
						}



					}
					else
					{
						int src1=sx+MW*sy;
						int src1x=play[sx+MW*sy]%MW;
						int src1y=play[sx+MW*sy]/MW;
						int src2=sx+MW*(sy+1);
						int src2x=play[sx+MW*(sy+1)]%MW;
						int src2y=play[sx+MW*(sy+1)]/MW;
						rectfill(buffer, 36+9*sx, 9+9*sy, 36+8+9*sx, 9+8+9+9*sy, makecol(0,0,0));

						masked_blit(bg,buffer,9*src1x,9*src1y,36+9*sx,9+9*sy+9-swaptimer,9,9);
						if (!removed[play[src1]])
						{
							masked_blit(fg,buffer,9*src1x,9*src1y,36+9*sx,9+9*sy+9-swaptimer,9,9);
						}

						masked_blit(bg,buffer,9*src2x,9*src2y,36+9*(sx),9+9*(sy+1)-9+swaptimer,9,9);
						if (!removed[play[src2]])
						{
							masked_blit(fg,buffer,9*src2x,9*src2y,36+9*(sx),9+9*(sy+1)-9+swaptimer,9,9);
						}


					}


				}


				//draw the cursor;

				if (cd)
				{//horizontal
					rect(buffer, 36+9*cx, 9+9*cy, 36+9+8+9*cx, 9+8+9*cy, makecol(255,255,255));
				}
				else
				{//vertical
					rect(buffer, 36+9*cx, 9+9*cy, 36+8+9*cx, 9+9+8+9*cy, makecol(255,255,255));

				}

				foreach(FallingData& f, falling)
				{
					std::cout<<f.tx<<","<<f.ty<<","<<36+f.x<<","<<f.y<<endl;
					masked_blit(fg,buffer,f.tx,f.ty,36+f.x,f.y,9,9);
					masked_blit(fg,buffer,f.tx,f.ty,90+f.x,f.y,9,9);
				}

			}
				break;
			case gs_outro:
			{
				if (endwait==0)
				{
					//draw stuff
					if (level<2)
						blit(bitmap[4],buffer,0,0,0,0,160,120);
					else
						blit(bitmap[8],buffer,0,0,0,0,160,120);

					rectfill(buffer, 6, 34, 152	, 110, makecol(0,0,0));
					rect(buffer, 6, 34, 152, 110, makecol(255,255,255));
					blit(bitmap[11],buffer,17*dialogues[level*2+1][curdialoguepos].speaker,0,15,46,17,18);
					wrapprint(dialogues[level*2+1][curdialoguepos].dialogue, 35, 40,13);

				}
//				otherwise just do nothing


			}
				break;
		}
		//start at 5
		//rect(buffer, 10, 30, 10+1000, 40, makecol(0,0,0));
		//end at 1024-5
		//vline(buffer, 10+pos, 30, 40, makecol(255,0,0));


	}

};

bool escheld=true;

template<class T>
void loop()
{

	escheld=true;
	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			if (key[KEY_ESC])
			{
				if (!escheld)
				{
					if (!TitleLoop::infopage)
						quit=true;
					else
					{
						TitleLoop::infopage=false;
						playsound(2);
					}
					escheld=true;
				}
			}
			else
			{
				escheld=false;
			}


			T::logic();

			if (T::quitcondition())
				return;


			speed_count--;

		}


		T::draw();

		stretch_blit(buffer, screen, 0, 0, 160, 120, 0, 0, 640, 480);
	}
}

void dotransition()
{
}

#define say(a,b) dialogues[cdialogue].push_back((CLine){a,b})

void makedialogues()
{
	int cdialogue=0;

	//1 start

	say(1,"Hey baby, all ready for the first set? ");
	say(0,"Oh you betcha Candy. ");
	say(1,"Go show 'em what you've got, eh? ");

	cdialogue=1;

	//1 end

	say(1,"Good show, girl, you really drove 'em wild! ");
	say(0,"Yeah, it seemed to go pretty well; when's my next set? ");
	say(1,"Pretty shortly. You better start getting changed right away. ");
	say(0,"No rest for the wicked, right? ");
	say(1,"Right on! ");


	cdialogue=2;
	//2 start
	say(1,"You all set, darlin'? ");
	say(0,"Yeah; going to go out there, have me a bit of fun. ");
	say(1,"I don't know where you get your energy! ");

	cdialogue=3;

	//2 end
	say(0,"How'd I do? ");
	say(1,"You need to ask with all the notes that got thrown your way? ");
	say(0,"I'm just heading home now; are you finishing up? ");
	say(1,"Yeah, just gotta get my titties out one more time then I'm gone. ");
	say(0,"Do you want a ride? ");
	say(1,"That'd be great, save me the cab-fare. ");
	say(0,"Great. I'm just going to go out back, have a cigarette. ");
	say(1,"See you in fifteen. ");

	cdialogue=4;
	//3 start
	say(2,"Hey you. ");
	say(0,"Huh? ");
	say(2,"You were very sexy tonight, darlin'. ");
	say(0,"Leave me alone, I'm on my break. ");
	say(2,"Ah, just let me touch your hair. ");
	say(0,"Don't FUCKING touch me you creep. ");
	say(2,"Oh, don't be like that, love. ");
	say(0,"Get your hands off me! ");
	say(2,"It'd be better for us both if you don't struggle, now wouldn't it? ");
	say(0,"Let go of me! ");


	cdialogue=5;

	//3 end
	say(1,"Oh my dear girl ... ");
	say(3,"Candy ... ");
	say(1,"Did you see who did this to you? ");
	say(3,"Some creep from the b...bar earlier. ");
	say(1,"We better go straight to the hospital. ");
}


void init()
{
	makedialogues();

	/* initialise everything */
	allegro_init();
	init_sound();

	//	int depth = desktop_color_depth();

	//	if (depth == 0) depth = 32;
	//		set_color_depth(depth);
	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;
	//CGDisplayHideCursor(kCGDirectMainDisplay);

	//init the buffer
	buffer=create_bitmap(160,120);

	for (int i=0;i<BMPCOUNT;i++)
		bitmap[i]=load_bitmap(bitmapnames[i],NULL);

	srand(time(0));
}

void drawthinkaboutmenu()
{
	/*
	drawpanel(x,y,blah,blah);
	printtext("think about")
	for (int i=0;i<9;i++)
	{
		blit(entityimage[i],x+tilewidth*(i/3),y+tilewidth*(i%3));
	}
	 */
}

int main(int argc, char *argv[])
{
	init();

	playmusic(0);

	loop<IntroLoop>();


	while (!quit)
	{
	title:
		loop<TitleLoop>();
		if (quit) goto leave;

		loop<GameLoop>();

		if (quit)
		{
			playmusic(0);
			quit=false;
			goto title;
		}


	}
			leave:

	return 0;
}
END_OF_MAIN()
