/*
 *  sound.hpp
 *  Template
 *
 *  Created by increpare on 16/01/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <aldumb.h>

const int pan = 128;
const int pitch = 1000;


AL_DUH_PLAYER *dplay; /* Holds the current playback state. */

const int XMCOUNT=5;
const char* xmpath[XMCOUNT]=
{
"xm/strippercutscene.xm",
"xm/stripperjingle.xm",
"xm/stripperlevel1.xm",
"xm/stripperlevel2.xm",
"xm/stripperlevel3.xm"
};


DUH* music[XMCOUNT];  

const int WAVCOUNT=5;
const char* wavpath[WAVCOUNT]=
{
"wav/getshape.wav",
"wav/play.wav",
"wav/select.wav",
"wav/swap.wav",
"wav/swap2.wav"
};
SAMPLE* sample[WAVCOUNT];

void stopmusic()
{
	if (dplay!=NULL) 
	{
		al_stop_duh(dplay);
		dplay=NULL;
	}
}

void playmusic(int i)
{
	
	stopmusic();
	dplay=al_start_duh(music[i],1,0,1.0f, 4096,11025);
}

void playsound(int i)
{
	play_sample(sample[i], 255, pan, pitch, FALSE);
}

void init_sound()
{
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	atexit(&dumb_exit);
	set_mixer_quality(0);
	dumb_register_stdfiles();

	

	//load music
	
	for (int i=0;i<XMCOUNT;i++)
		music[i] = dumb_load_xm_quick(xmpath[i]);
	for (int i=0;i<WAVCOUNT;i++)
		sample[i] = load_wav(wavpath[i]);
	
	
	
}